<?php
/********************************************************
Coppermine 1.5.x Plugin - Google Maps
*******************************************************
Copyright (c) 2010 Alexander Usachev (alex@a-l-e-x.ru)
*******************************************************/
  
if (!defined('IN_COPPERMINE')) {
    die('Not in Coppermine...');
}

if (defined('DISPLAYIMAGE_PHP')) {
    $thisplugin->add_filter('file_info','google_maps_view');
    $thisplugin->add_filter('page_meta','google_maps_gallery_header'); // (shows just above the gallery)
}

//CMFA==>
function getGps($exifCoord, $hemi) {

    $degrees = count($exifCoord) > 0 ? gps2Num($exifCoord[0]) : 0;
    $minutes = count($exifCoord) > 1 ? gps2Num($exifCoord[1]) : 0;
    $seconds = count($exifCoord) > 2 ? gps2Num($exifCoord[2]) : 0;

    $flip = ($hemi == 'W' or $hemi == 'S') ? -1 : 1;

    return $flip * ($degrees + $minutes / 60 + $seconds / 3600);

}

function gps2Num($coordPart) {

    $parts = explode('/', $coordPart);

    if (count($parts) <= 0)
        return 0;

    if (count($parts) == 1)
        return $parts[0];

    return floatval($parts[0]) / floatval($parts[1]);
}
//<==CMFA

function google_maps_view($html) {
    global $CURRENT_PIC_DATA, $CONFIG;

  if (file_exists("plugins/google_maps/lang/{$CONFIG['lang']}.php")){
    require "plugins/google_maps/lang/{$CONFIG['lang']}.php";
  }else{
    require "plugins/google_maps/lang/english.php";
  }
 
  $exif = read_exif_data(get_pic_url($CURRENT_PIC_DATA));
  $lon = getGps($exif["GPSLongitude"], $exif['GPSLongitudeRef']);
  $lat = getGps($exif["GPSLatitude"], $exif['GPSLatitudeRef']);
    
  if ($lon && $lat){

$html[$lang_plugin_google_maps['infoheader']] = <<< EOT
        <a href="javascript:;" onclick= "showmap({$lon},{$lat});"><strong>{$lang_plugin_google_maps['longitude']}: {$lon}, {$lang_plugin_google_maps['latitude']}: {$lat}</strong></a>
        <div id ="gmaps3_block" class="gmaps3_block"></div>
EOT;
    } else {
        $html[$lang_plugin_google_maps['infoheader']] = $lang_plugin_google_maps['nodata'];
    }
    return $html;
}

function google_maps_gallery_header($meta) {
    global $JS;
    if (in_array('plugins/google_maps/script.js', $JS['includes']) != TRUE) {
        $JS['includes'][] = 'plugins/google_maps/script.js';
    }
$meta .= <<< EOT
<link rel="stylesheet" href="plugins/google_maps/style.css" type="text/css" />
<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false"></script>
EOT;

return $meta;
}   
?>